package com.sun.media.sound;

import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.spi.FormatConversionProvider;

abstract class SunCodec extends FormatConversionProvider
{
    private final AudioFormat.Encoding[] inputEncodings;
    private final AudioFormat.Encoding[] outputEncodings;
    
    SunCodec(AudioFormat.Encoding[] inputEncodings, AudioFormat.Encoding[] outputEncodings) {
        this.inputEncodings = inputEncodings;
        this.outputEncodings = outputEncodings;
    }
    
    @Override
    public final AudioFormat.Encoding[] getSourceEncodings() {
        AudioFormat.Encoding[] array = new AudioFormat.Encoding[this.inputEncodings.length];
        System.arraycopy(this.inputEncodings, 0, array, 0, this.inputEncodings.length);
        return array;
    }
    
    @Override
    public final AudioFormat.Encoding[] getTargetEncodings() {
        AudioFormat.Encoding[] array = new AudioFormat.Encoding[this.outputEncodings.length];
        System.arraycopy(this.outputEncodings, 0, array, 0, this.outputEncodings.length);
        return array;
    }
    
    @Override
    public abstract AudioFormat.Encoding[] getTargetEncodings(AudioFormat p0);
    
    @Override
    public abstract AudioFormat[] getTargetFormats(AudioFormat.Encoding p0, AudioFormat p1);
    
    @Override
    public abstract AudioInputStream getAudioInputStream(AudioFormat.Encoding p0, AudioInputStream p1);
    
    @Override
    public abstract AudioInputStream getAudioInputStream(AudioFormat p0, AudioInputStream p1);
}
